Unit de36e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AS08E_p, UTDE17_p;

procedure de36e(FA :Proc_F3E_DE; FI :Proc_F3E_DE; M :Integer;
                var JSTART :Integer; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var IR :Array of Integer;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var R4 :Array of Extended;
                var R5 :Array of Extended; var IERR :Integer);

implementation

procedure de36e(FA :Proc_F3E_DE; FI :Proc_F3E_DE; M :Integer;
                var JSTART :Integer; HMIN :Extended; EPS :Extended;
                P :Extended; var YX :Array of Extended; var X :Extended;
                var H :Extended; var BUL :Boolean; var XP :Extended;
                var YP :Array of Extended; var IR :Array of Integer;
                var R1 :Array of Extended; var R2 :Array of Extended;
                var R3 :Array of Extended; var R4 :Array of Extended;
                var R5 :Array of Extended; var IERR :Integer);
var
I,ISTR,J,J1,J2,JUMP,JUMP1,L :Integer;
H1,W,W1,W2,W3,W4 :Extended;
BULH,BULHM :Boolean;
CMU :Array [0..14] of Extended;
MU :Array [0..14] of Extended;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320;
begin
{   DATA  FORTRAN  }
MU[0] := 0.11270166537925831148e0;
MU[1] := 0.5e0;
MU[2] := 0.887298334620741688518e0;
MU[3] := 0.13888888888888888889e0;
MU[4] := -0.0359766675249389034564e0;
MU[5] := 0.97894440153083260496e-2;
MU[6] := 0.30026319498086459244e0;
MU[7] := 0.22222222222222222222e0;
MU[8] := -0.022485417203086814660e0;
MU[9] := 0.26798833376246945173e0;
MU[10] := 0.48042111196938334790e0;
MU[11] := 0.13888888888888888889e0;
MU[12] := 0.27777777777777777778e0;
MU[13] := 0.44444444444444444444e0;
MU[14] := 0.27777777777777777778e0;
IERR := 0;
for I:=1 to 15 do
 begin
  CMU[I-1] := MU[I-1]*H;
_10:
 end;
BULHM := False;
BULH := True;
if ( JSTART =  -1 ) 
 then goto _290;
if ( JSTART =  1 ) 
 then goto _20;
_COM36D.elm4 := M + 1;
_COM36D.elm5 := _COM36D.elm4 + M;
_COM36D.elm1 := M*3;
_COM36D.elm2 := _COM36D.elm1 + 1;
_COM36D.elm3 := _COM36D.elm1*_COM36D.elm1;
_COM36D.elm6 := M*_COM36D.elm1;
_20:
for I:=1 to M do
 begin
  YP[I-1] := YX[I-1];
_30:
 end;
XP := X;
_40:
JUMP1 := 1;
_COM36D.elm7 := EPS*63.e0;
_COM36D.elm8 := _COM36D.elm7/128.e0;
{   **********  BOHEHE AAHHOO AA  H   ********** }
goto _120;
{   **********  AOMHAHE PEEH  OEHK OPEHOCT  ********** }
_50:
for I:=1 to M do
 begin
  R4[I-1] := YX[I-1];
_60:
 end;
_70:
for I:=1 to 15 do
 begin
  CMU[I-1] := CMU[I-1]*0.5e0;
_80:
 end;
H1 := H*0.5e0;
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_90:
 end;
X := XP;
JUMP1 := 2;
{   **********  BOHEHE EPBOO OOBHHOO AA  H/2    ********** }
goto _120;
_100:
for I:=1 to M do
 begin
  R5[I-1] := YX[I-1];
_110:
 end;
X := X + H1;
{   **********  BOHEHE BTOPOO OOBHHOO AA  H/2    ********** }
JUMP1 := 3;
{   **********  OPMPOBAHE PACPEHHO MATP   ********** }
_120:
W := X + CMU[0];
W1 := CMU[3];
W2 := CMU[4];
W3 := CMU[5];
ISTR := 1;
JUMP := 1;
goto _150;
_130:
W := X + CMU[1];
W1 := CMU[6];
W2 := CMU[7];
W3 := CMU[8];
ISTR := _COM36D.elm4;
JUMP := 2;
goto _150;
_140:
W := X + CMU[2];
W1 := CMU[9];
W2 := CMU[10];
W3 := CMU[11];
ISTR := _COM36D.elm5;
JUMP := 3;
{   **********  OPMPOBAHE OPOHTAHO OOC B PACPEHHO  ******* }
{   **********   MATPE  ********** }
_150:
FA(R3,W,M);
FI(R2,W,M);
J := ISTR - 1;
for I:=1 to M do
 begin
  J := J + 1;
  W := 0.0e0;
  J1 := J - _COM36D.elm1;
  for L:=1 to M do
   begin
    J1 := J1 + _COM36D.elm1;
    W4 := R3[(I-1)+(L-1)*M];
    R1[J1-1] := W4*W1;
    J2 := J1 + _COM36D.elm6;
    R1[J2-1] := W4*W2;
    J2 := J2 + _COM36D.elm6;
    R1[J2-1] := W4*W3;
    W := W + W4*YX[L-1];
_160:
   end;
  L := _COM36D.elm3 + J;
  R1[L-1] := -R2[I-1] - W;
_170:
 end;
case JUMP of
 1: goto _130;
 2: goto _140;
 3: goto _180;
end;
_180:
I := 1;
while ( I<=_COM36D.elm3 ) do
 begin
  R1[I-1] := R1[I-1] - 1.0e0;
_190:
  inc(I,_COM36D.elm2);
 end;
AS08E(_COM36D.elm1,0,_COM36D.elm1,R1,R2,IR);
for I:=1 to M do
 begin
  J := I + M;
  J1 := J + M;
  YX[I-1] := YX[I-1] + CMU[12]*R2[I-1] + CMU[13]*R2[J-1] + CMU[14]*
    R2[J1-1];
_200:
 end;
case JUMP1 of
 1: goto _50;
 2: goto _100;
 3: goto _210;
end;
_210:
for I:=1 to M do
 begin
  W := YX[I-1] - R4[I-1];
  if ( Abs(YX[I-1]) >  P ) 
   then W := W/YX[I-1];
  W := Abs(W);
  if ( W <=  _COM36D.elm7 ) 
   then goto _220;
  if ( BULHM ) 
   then goto _310;
  H := H1;
  BUL := False;
  BULH := False;
  if ( Abs(H) >  Abs(HMIN) ) 
   then goto _240;
  H := Sign(HMIN,H);
  BULHM := True;
  goto _260;
_220:
  if ( W <  _COM36D.elm8 ) 
   then goto _230;
  BULH := False;
_230:
 end;
X := X + H1;
if ( BULH ) 
 then H := H + H;
goto _320;
_240:
for I:=1 to M do
 begin
  R4[I-1] := R5[I-1];
_250:
 end;
goto _70;
_260:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_270:
 end;
for I:=1 to 15 do
 begin
  CMU[I-1] := MU[I-1]*H;
_280:
 end;
X := XP;
goto _40;
_290:
for I:=1 to M do
 begin
  YX[I-1] := YP[I-1];
_300:
 end;
X := XP;
goto _40;
_310:
IERR := 65;
UTDE17(IERR,36);
_320:
JSTART := 1;
end;

end.
